/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */
module.exports = {

    "id": "Q10",
    "name": "BlackBerry Q10",
    "model": "Q10",
    "osName": "BlackBerry",
    "uuid": "42",
    "osVersion": "10.1",
    "manufacturer": "BlackBerry",
    "hardwareId": "0x8400270a",

    "capabilities": [
        "input.touch",
        "location.gps",
        "media.audio.capture",
        "media.video.capture",
        "media.recording",
        "network.bluetooth",
        "network.wlan"
    ],

    "screen": {
        "width": 720,
        "height": 720
    },
    "viewPort": {
        "portrait": {
            "width": 720,
            "height": 720,
            "paddingTop": 0,
            "paddingLeft": 0
        }
    },

    "defaultOrientation": "portrait",

    "ppi": 330,
    "userAgent": "Mozilla/5.0 (BB10; Kbd) AppleWebKit/537.10+ (KHTML, like Gecko) Version/10.1.0.42 Mobile Safari/537.10+",
    "platforms": ["web", "webworks.bb10", "cordova"],
    "mediaQueryEmulation": {
        "-webkit-device-pixel-ratio": 2.08
    }
};
