/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */
var camera = ripple('ui/plugins/camera'),
    event = ripple('event'),
    card = {
        invokeCamera: function (mode, onSave, onCancel, onInvoke) {
            //defaults everything to image, unless it is video
            var type = mode === 'video' ? 'video' : 'image';

            event.once("captured-" + type, function (path) {
                return onSave && onSave(path);
            });

            camera.show(type);

            if (onInvoke) {
                onInvoke("");
            }
        }
    };

card.__defineGetter__("CAMERA_MODE_PHOTO", function () { return "photo"; });
card.__defineGetter__("CAMERA_MODE_VIDEO", function () { return "video"; });
card.__defineGetter__("CAMERA_MODE_FULL", function () { return "full"; });

module.exports = card;
